/**
/*   Copyright (c) 2003by  Marco Welti
/*
/*   This document is  bound by the  QT Public License
/*   (http://www.trolltech.com/licenses/qpl.html).
/*   See License.txt for more information.
/*
/*
/*
/*   ALL RIGHTS RESERVED.  
/* 
/*   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
/*   OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
/*   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
/*   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
/*   DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
/*   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
/*   GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
/*   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
/*   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
/*   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
/*   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/* 
/***********************************************************************/

// CommandHandler.cpp : Implementation of CommandHandler
#include "stdafx.h"
#include "ESBDSAddin.h"
#include "CommandHandler.h"
#include "DSAddIn.h"
#include "ComHelper.h"

using namespace std;
/////////////////////////////////////////////////////////////////////////////
// CommandHandler

void CommandHandler::showBrowser(const string &browser)
{
    CComPtr< IDispatch> tmp = 0;

    cex_ = getAddIn()->getApplication()->get_ActiveDocument(&tmp);
    CComQIPtr<ITextDocument> active = tmp;
    
    tmp = 0;
    cex_ = active->get_Selection(&tmp);
    CComQIPtr<ITextSelection> selection = tmp;
    
    CComBSTR what;
    cex_ = selection->get_Text(&what);

    getAddIn()->showBrowser(browser, string(bstr_t(what)));
}


HRESULT CommandHandler::setProperties()
{
  SANDBOX_BEGIN("CommandHandler" , "setProperties")

  getAddIn()->modifyProperties();

  SANDBOX_END()

  return S_OK;
}

HRESULT CommandHandler::showOutlineBrowser()
{
  SANDBOX_BEGIN("CommandHandler", "showOutlineBrowser")
 
  showBrowser("outline");

  SANDBOX_END()

  return S_OK;
}

HRESULT CommandHandler::showHierarchyBrowser()
{
  SANDBOX_BEGIN("CommandHandler", "showHierarchyBrowser")
  
  showBrowser("hierarchy");

  SANDBOX_END()
    
  return S_OK;
}

HRESULT CommandHandler::showTypeBrowser()
{
  SANDBOX_BEGIN("CommandHandler", "showTypeBrowser")
    
  showBrowser("types");

  SANDBOX_END()
    
  return S_OK;
}

HRESULT CommandHandler::showMethodBrowser()
{
  SANDBOX_BEGIN("CommandHandler", "showMethodBrowser")

  showBrowser("methods");

  SANDBOX_END()
    
  return S_OK;
}

HRESULT CommandHandler::showWorkspaceBrowser()
{
  SANDBOX_BEGIN("CommandHandler", "showWorkspaceBrowser")

  showBrowser("workspace");
  
  SANDBOX_END()
    
  return S_OK;
}
