/**
/*   Copyright (c) 2003by  Marco Welti
/*
/*   This document is  bound by the  QT Public License
/*   (http://www.trolltech.com/licenses/qpl.html).
/*   See License.txt for more information.
/*
/*
/*
/*   ALL RIGHTS RESERVED.  
/* 
/*   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
/*   OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
/*   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
/*   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
/*   DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
/*   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
/*   GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
/*   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
/*   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
/*   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
/*   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/* 
/***********************************************************************/

#ifndef CTagsHierarchyLoader_H
#define CTagsHierarchyLoader_H

#include "Model/HierarchyLoader.h"

class Workspace;
 
namespace CTags
{

class Database;
class Tag;

class HierarchyLoader : public ::HierarchyLoader
{
private:
  smart_ptr<Workspace> mWorkspace;

public:
  HierarchyLoader(const smart_ptr<Workspace> &ws) : mWorkspace(ws) {};
  
  virtual Inheritable& loadHierarchy(Inheritable&, bool recursive = false);
  virtual std::list<smart_ptr<Inheritable> > loadSubtypeHierarchy(const Inheritable&, bool recursive = false);
  virtual std::list<smart_ptr<Inheritable> > loadSupertypeHierarchy(const Inheritable&, bool recursive = false);

private:
  std::list<smart_ptr<Inheritable> > getSuperHierarchy(const std::string &fqn, bool recursive);
  std::list<smart_ptr<Inheritable> > getSubHierarchy(const std::string &fqn, bool recursive);
  Tag getTag(const std::string &fqn);
  smart_ptr<Inheritable> makeRootNode(const Tag&);
  smart_ptr<Inheritable> makeUnknown(const std::string&);
  Database& getDatabase();

};


}
#endif