/**
/*   Copyright (c) 2003by  Marco Welti
/*
/*   This document is  bound by the  QT Public License
/*   (http://www.trolltech.com/licenses/qpl.html).
/*   See License.txt for more information.
/*
/*
/*
/*   ALL RIGHTS RESERVED.  
/* 
/*   THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS
/*   OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
/*   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
/*   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY
/*   DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
/*   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
/*   GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
/*   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
/*   WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
/*   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
/*   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
/* 
/***********************************************************************/

#include <stdafx.h>

#include "VSEditor.h"



#include "../../ESBDSAddIn/src/ESBDSAddIn_i.c"

VisualStudioEditor::VisualStudioEditor(const std::string &file)
: mFile(file)
{
  message_box("VisualStudioEditor(): will search for addin");
  HRESULT hr = mAddin.CoCreateInstance( CLSID_ESBDSAddin);//, NULL, CLSCTX_LOCAL_SERVER, IID_IESBDSAddin, reinterpret_cast< void**>(&mAddin));
  if(FAILED(hr))
  {
    message_box("failed to connect to file viewer plugin");
    message_box(_com_error(hr).ErrorMessage());
  }
}

VisualStudioEditor::VisualStudioEditor(const CComPtr<IESBDSAddin> &addin, const std::string &file)
: mFile(file), mAddin(addin)
{
}

void VisualStudioEditor::openFile(const std::string &file)
{
  mFile = file;
}

void VisualStudioEditor::goToLine(size_t line)
{
  if(mAddin != NULL) {
    mAddin->gotoLine( CComBSTR(mFile.c_str()), line);
  }
}


VisualStudioEditorBroker::VisualStudioEditorBroker(const CComPtr<IESBDSAddin> &addin)
: mAddin(addin)
{
}


smart_ptr<Editor> VisualStudioEditorBroker::getEditor(const std::string file)
{
  return make_smart_ptr(new VisualStudioEditor(mAddin, file));
}


